"""move from sqlite

迁移 ID: 0105684994ff
父迁移: a9b783356705
创建时间: 2024-05-24 18:57:54.899076

"""

from __future__ import annotations

from collections.abc import Sequence
import sqlite3 as sql

from alembic import op
from nonebot import logger, require
from sqlalchemy.ext.automap import automap_base
from sqlalchemy.orm import Session

revision: str = "0105684994ff"
down_revision: str | Sequence[str] | None = "a9b783356705"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def move_from_sqlite():
    import nonebot_plugin_localstore as store

    database_file = store.get_data_file("sync_message_to_discord", "msgid.db")
    if database_file.exists():
        logger.info("dcqg_relay: 发现来自 msgid.db 的数据，正在迁移...")
        Base = automap_base()
        Base.prepare(autoload_with=op.get_bind())
        MsgID = Base.classes.nonebot_plugin_dcqg_relay_msgid
        session = Session(op.get_bind())
        sql_conn = sql.connect(database_file)
        datas = sql_conn.execute("SELECT * FROM ID").fetchall()
        sql_conn.close()
        for data in datas:
            session.add(MsgID(dcid=data[0], qqid=data[1]))
        session.commit()
        logger.info("dcqg_relay: 迁移完成")


def upgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    try:
        require("nonebot_plugin_localstore")
    except RuntimeError:
        return

    move_from_sqlite()
    # ### end Alembic commands ###


def downgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
